#import <UIKit/UIKit.h>
#import "Core.h"

#define UIColorFromRGB(rgbValue) \
[UIColor colorWithRed:((float)((rgbValue & 0xFF0000) >> 16))/255.0 \
green:((float)((rgbValue & 0x00FF00) >>  8))/255.0 \
blue:((float)((rgbValue & 0x0000FF) >>  0))/255.0 \
alpha:1.0]

@interface Util : NSObject

+ (void)saveToSettings:(NSString *)key withValue:(NSString *)value;
+ (NSString*)getFromSettings:(NSString *)key;
+ (CoreMode)coreMode:(NSString *)mode;
+ (NSString*)parseCoreError:(CoreError)error withMessage:(NSString*) message;
+ (NSString*)parseCoreDeviceError:(CoreDeviceError)deviceError withDescription:(NSString *)message;
+ (NSString*)parseCoreMessage:(CoreMessage)message;
+ (NSString *)findCurrencySymbolByCode:(NSString *)_currencyCode;
+ (NSString *)formatDateToServerFormat:(NSDate *)date;

@end

@interface NSData (NSData_Conversion)

- (NSString *)hexadecimalString;

@end

@interface TableData : NSObject

@property NSString* firstDescription;
@property NSString* firstRightDescription;
@property NSString* secondDescription;
@property NSString* secondRightDescrition;

@end
